*
* usage: ogen [noplot] cylinder -factor=<num> -order=[2/4/6/8]
*
* Examples:
*  ogen noplot cylinder -factor=1
*  ogen noplot cylinder -factor=2
#
*  ogen noplot cylinder -order=4 -factor=1
*  ogen noplot cylinder -order=4 -factor=2
*
# -- save current values of parameters so this script can be called by CG scripts
$orderCylinder=$order; $orderOfAccuracyCylinder=$orderOfAccuracy; 
$order=2; $factor=1; $interp="i"; # default values
$orderOfAccuracy = "second order"; $ng=2; 
* 
* get command line arguments
Getopt::Long::Configure("prefix_pattern=(--grid_|--|-)");
GetOptions( "order=i"=>\$order,"factor=i"=> \$factor);
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=2; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=6; }
* 
$suffix = ".order$order"; 
$name = "cylinder" . "$factor" . $suffix . ".hdf";
*
$innerRad=.5; $outerRad=1.; $za=-.5; $zb=.5; 
$bc="-1 -1 1 2 3 4"; 
*
* $grid = "cylinder.hdf"; $bc="-1 -1 -1 -1 1 1"; 
* $factor=1; $name = "cylinder$factor.hdf"; 
* $factor=2; $name = "cylinder$factor.hdf"; 
* $factor=4; $name = "cylinder$factor.hdf"; 
*
$ds = .1/$factor;
*
create mappings
  cylinder
    lines
     $nTheta=int( 2.*3.1415*($innerRad+$outerRad)*.5/$ds + 1.5);
     $nr = int( ($outerRad-$innerRad)/$ds + 1.5 );
     $nz = int(($zb-$za)/$ds + 1.5);
     * 21 3 5   6 3 5   5 3 5 <-ok  5 3 4 <-ok  5 3 3  7 3 5   5 3 4   5 3 3   9 3 5  33 3 7 
     $nTheta $nz $nr 
    bounds on the radial variable
     $innerRad $outerRad=1.
    bounds on the axial variable
      $za $zb
    boundary conditions
      $bc
    mappingName
     cylinder
*    periodicity
*      2 1 0
    exit
exit
*
  generate an overlapping grid
    cylinder
  change parameters
    ghost points
      all
      $ng $ng $ng $ng $ng $ng
    order of accuracy
     $orderOfAccuracy  
  exit
  compute overlap
* 
  exit
*
save an overlapping grid
$name
cylinder
$order=$orderCylinder; $orderOfAccuracy=$orderOfAccuracyCylinder;  # reset 
exit
