*
* make a grid for a square:
* usage: ogen [noplot] square -nx=<num> -order=[2/4/6/8] 
* 
* examples:
*
*     ogen noplot squareArg -nx=10 
*     ogen noplot squareArg -nx=20 
*     ogen noplot squareArg -nx=40 
*     ogen noplot squareArg -nx=80
*     ogen noplot squareArg -nx=1024
* 
*     ogen noplot squareArg -nx=9  
*     ogen noplot squareArg -nx=17 
*     ogen noplot squareArg -nx=33 
* 
*     ogen noplot squareArg -nx=11 -order=2
*     ogen noplot squareArg -nx=8  
*     ogen noplot squareArg -nx=16
*     ogen noplot squareArg -nx=32 
*     ogen noplot squareArg -nx=64
* 
*     ogen noplot squareArg -order=4 -nx=5
*     ogen noplot squareArg -order=4 -nx=8
*     ogen noplot squareArg -order=4 -nx=10 
*     ogen noplot squareArg -order=4 -nx=16 
*     ogen noplot squareArg -order=4 -nx=32 
*     ogen noplot squareArg -order=4 -nx=64
*     ogen noplot squareArg -order=4 -nx=128
*     ogen noplot squareArg -order=4 -nx=256
*     ogen noplot squareArg -order=4 -nx=512
*     ogen noplot squareArg -order=4 -nx=1024    (2^10)
*     ogen noplot squareArg -order=4 -nx=2048    (2^11)
*     ogen noplot squareArg -order=4 -nx=4096    (2^12 = 16.8M)
*     ogen noplot squareArg -order=4 -nx=8192    (2^13 = 67M)
*     srun -N1 -n8 -ppdebug $ogenp noplot squareArg -order=4 -nx=16384   (2^14 = 268M
*     srun -N2 -n8 -ppdebug $ogenp noplot squareArg -order=4 -nx=32768   (2^15 = 1.1B
*     srun -N8 -n16 -ppdebug $ogenp noplot squareArg -order=4 -nx=65536  (2^16 = 4.3B
*     ogen noplot squareArg -order=4 -nx=131072  (2^17 
*     ogen noplot squareArg -order=4 -nx=262,144 (2^18
*     ogen noplot squareArg -order=4 -nx=
* 
*     ogen noplot squareArg -order=4 -nx=10 
*     ogen noplot squareArg -order=4 -nx=20 
*     ogen noplot squareArg -order=4 -nx=40 
*     ogen noplot squareArg -order=4 -nx=80 
*     ogen noplot squareArg -order=4 -nx=160
* 
* see also the script buildSquares
*
$order=2; $n=10; # default values
$orderOfAccuracy = "second order"; $ng=2;
* 
* get command line arguments
GetOptions( "order=i"=>\$order,"nx=i"=> \$n);
$nx=$n+1; 
* 
if( $order eq 4 ){ $orderOfAccuracy="fourth order"; $ng=2; }\
elsif( $order eq 6 ){ $orderOfAccuracy="sixth order"; $ng=4; }\
elsif( $order eq 8 ){ $orderOfAccuracy="eighth order"; $ng=6; }
* 
$lines = $nx;
$suffix = ".order$order"; 
* 
* $lines = 11;	
* $lines = 1025;	
* $lines = 2049;	
* $lines = 4097;	
* $lines = "17"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "21"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "33"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "41"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "65"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* $lines = "129"; $orderOfAccuracy = "fourth order"; $suffix=".order4"; $ng=2; 
* 
* $lines = "17"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "33"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "65"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* $lines = "129"; $orderOfAccuracy = "sixth order"; $suffix=".order6"; $ng=3; 
* 
* $lines = "17"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "33"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "65"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* $lines = "129"; $orderOfAccuracy = "eighth order"; $suffix=".order8"; $ng=4; 
* 
$cells = $lines -1;
$name = "square" . "$cells" . $suffix;
*
create mappings
  rectangle
    mappingName
      square
    lines
      $lines $lines
    boundary conditions
      1 2 3 4
  exit
exit
*
generate an overlapping grid
  square
  done
  change parameters
    ghost points
      all
      $ngp = $ng+1;
      $ng $ng $ng $ngp $ng $ng
    order of accuracy
      $orderOfAccuracy
  exit
  compute overlap
  display computed geometry
exit
*
save an overlapping grid
  $name.hdf
  $name
exit

